Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IChart.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IChart.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IChart.cs	(revision 13045)
@@ -27,5 +27,6 @@
 namespace HeuristicLab.Visualization {
   public interface IChart {
-    ChartMode Mode { get; set; }
+    bool Enabled { get; set; }
+
     PointD LowerLeft { get; }
     PointD UpperRight { get; }
@@ -35,5 +36,4 @@
     SizeD WorldToPixelRatio { get; }
     IGroup Group { get; }
-    bool UpdateEnabled { get; }
 
     PointD TransformPixelToWorld(Point point);
@@ -43,38 +43,27 @@
 
     void SetPosition(PointD lowerLeft, PointD upperRight);
-    void SetPosition(double x1, double y1, double x2, double y2);
     void Move(Offset delta);
-    void Move(double dx, double dy);
 
+    void ZoomIn(Point mousePosition);
     void ZoomIn(PointD lowerLeft, PointD upperRight);
-    void ZoomIn(double x1, double y1, double x2, double y2);
     void ZoomIn(Point lowerLeft, Point upperRight);
-    void ZoomIn(int x1, int y1, int x2, int y2);
     void ZoomOut();
     void Unzoom();
 
+    void IntoForeground(IPrimitive primitive);
+    void IntoBackground(IPrimitive primitive);
+    void OneLayerUp(IPrimitive primitive);
+    void OneLayerDown(IPrimitive primitive);
+
+    string GetToolTipText(Point point);
+    Cursor GetCursor(Point point);
+
     IPrimitive GetPrimitive(Point point);
-    IPrimitive GetPrimitive(int x, int y);
-    IList<IPrimitive> GetAllPrimitives(Point point);
-    IList<IPrimitive> GetAllPrimitives(int x, int y);
-
-    Cursor GetCursor(Point point);
-    Cursor GetCursor(int x, int y);
-    string GetToolTipText(Point point);
-    string GetToolTipText(int x, int y);
-
-    void MouseClick(Point point, MouseButtons button);
-    void MouseClick(int x, int y, MouseButtons button);
-    void MouseDoubleClick(Point point, MouseButtons button);
-    void MouseDoubleClick(int x, int y, MouseButtons button);
-    void MouseMove(Point start, Point end);
-    void MouseMove(int x1, int y1, int x2, int y2);
-    void MouseDrag(Point start, Point end, MouseButtons button);
-    void MouseDrag(int x1, int y1, int x2, int y2, MouseButtons button);
+    IEnumerable<IPrimitive> GetAllPrimitives(Point point);
 
     void Render(Graphics graphics, int width, int height);
 
-    event EventHandler Update;
-    void EnforceUpdate();
+    event EventHandler RedrawRequired;
+    void RaiseRedrawRequired();
   }
 }
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IGrid.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IGrid.cs	(revision 13045)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IGrid.cs	(revision 13045)
@@ -0,0 +1,12 @@
+﻿
+namespace HeuristicLab.Visualization {
+  public interface IGrid {
+    PointD Origin { get; set; }
+    double XPrecision { get; }
+    double YPrecision { get; }
+
+    PointD GetBottomLeftGridPoint(PointD point);
+    PointD GetUpperRightGridPoint(PointD point);
+    PointD GetNearestGridPoint(PointD point);
+  }
+}
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IGroup.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IGroup.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IGroup.cs	(revision 13045)
@@ -20,13 +20,11 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
 using System.Collections.ObjectModel;
-using System.Text;
 
 namespace HeuristicLab.Visualization {
-  public interface IGroup : IPrimitive {
-    ReadOnlyCollection<IPrimitive> Primitives { get; }
-    ReadOnlyCollection<IPrimitive> SelectedPrimitives { get; }
+  public interface IGroup : IPrimitive, IEnumerable<IPrimitive> {
+    IEnumerable<IPrimitive> Primitives { get; }
+    IEnumerable<IPrimitive> SelectedPrimitives { get; }
 
     void Add(IPrimitive primitive);
@@ -37,7 +35,5 @@
 
     IPrimitive GetPrimitive(PointD point);
-    IPrimitive GetPrimitive(double x, double y);
-    IList<IPrimitive> GetAllPrimitives(PointD point);
-    IList<IPrimitive> GetAllPrimitives(double x, double y);
+    IEnumerable<IPrimitive> GetAllPrimitives(PointD point);
 
     void OneLayerUp(IPrimitive primitive);
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IPrimitive.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IPrimitive.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Interfaces/IPrimitive.cs	(revision 13045)
@@ -21,6 +21,4 @@
 
 using System;
-using System.Collections.Generic;
-using System.Text;
 using System.Drawing;
 using System.Windows.Forms;
@@ -28,9 +26,6 @@
 namespace HeuristicLab.Visualization {
   public interface IPrimitive {
-    IChart Chart { get; }
-    IGroup Group { get; set; }
     Pen Pen { get; set; }
     Brush Brush { get; set; }
-    bool UpdateEnabled { get; }
     bool Selected { get; set; }
     string ToolTipText { get; set; }
@@ -38,27 +33,12 @@
 
     void Move(Offset delta);
-    void Move(double dx, double dy);
+    void Move(PointD point, Offset delta);
+
+    void SnapToGrid(IGrid grid);
+    void SnapToGrid(PointD point, IGrid grid);
 
     bool ContainsPoint(PointD point);
-    bool ContainsPoint(double x, double y);
-
     Cursor GetCursor(PointD point);
-    Cursor GetCursor(double x, double y);
     string GetToolTipText(PointD point);
-    string GetToolTipText(double x, double y);
-
-    void OneLayerUp();
-    void OneLayerDown();
-    void IntoForeground();
-    void IntoBackground();
-
-    void MouseClick(PointD point, MouseButtons button);
-    void MouseClick(double x, double y, MouseButtons button);
-    void MouseDoubleClick(PointD point, MouseButtons button);
-    void MouseDoubleClick(double x, double y, MouseButtons button);
-    void MouseMove(PointD point, Offset offset);
-    void MouseMove(double x, double y, double dx, double dy);
-    void MouseDrag(PointD point, Offset offset, MouseButtons button);
-    void MouseDrag(double x, double y, double dx, double dy, MouseButtons button);
 
     void PreDraw(Graphics graphics);
@@ -66,6 +46,5 @@
     void PostDraw(Graphics graphics);
 
-    event EventHandler Update;
-    void EnforceUpdate();
+    event EventHandler RedrawRequired;
   }
 }
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Plugin.cs.frame
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Plugin.cs.frame	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Plugin.cs.frame	(revision 13045)
@@ -26,6 +26,7 @@
 
 namespace HeuristicLab.Visualization {
-  [Plugin("HeuristicLab.Visualization", "3.3.1.$WCREV$")]
+  [Plugin("HeuristicLab.Visualization", "3.3.12.$WCREV$")]
   [PluginFile("HeuristicLab.Visualization-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   public class HeuristicLabVisualizationPlugin : PluginBase { }
 }
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Axis.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Axis.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Axis.cs	(revision 13045)
@@ -21,30 +21,23 @@
 
 using System;
-using System.Collections.Generic;
-using System.Text;
 using System.Drawing;
 
 namespace HeuristicLab.Visualization {
   public class Axis : AxisPrimitiveBase {
+    protected const int PixelsPerInterval = 100;
+
     public Axis(IChart chart, PointD point, AxisType axisType)
       : base(chart, point, axisType) {
-    }
-    public Axis(IChart chart, double x, double y, AxisType axisType)
-      : this(chart, new PointD(x, y), axisType) {
     }
     public Axis(IChart chart, PointD point, AxisType axisType, Pen pen, Brush brush)
       : base(chart, point, axisType, pen, brush) {
     }
-    public Axis(IChart chart, double x, double y, AxisType axisType, Pen pen, Brush brush)
-      : this(chart, new PointD(x, y), axisType, pen, brush) {
-    }
 
     public override void Draw(Graphics graphics) {
-      int pixelsPerInterval = 100;
-      Font axisValuesFont = new Font(FontFamily.GenericSansSerif, 10, FontStyle.Regular, GraphicsUnit.Pixel);
-      Font axisLabelsFont = new Font(FontFamily.GenericSansSerif, 14, FontStyle.Regular, GraphicsUnit.Pixel);
+      var axisValuesFont = new Font(FontFamily.GenericSansSerif, 10, FontStyle.Regular, GraphicsUnit.Pixel);
+      var axisLabelsFont = new Font(FontFamily.GenericSansSerif, 14, FontStyle.Regular, GraphicsUnit.Pixel);
 
       if ((AxisType & AxisType.Horizontal) == AxisType.Horizontal) {
-        int intervals = Chart.SizeInPixels.Width / pixelsPerInterval;
+        int intervals = Chart.SizeInPixels.Width / PixelsPerInterval;
 
         if (intervals > 0) {
@@ -57,5 +50,5 @@
 
           double x = Math.Floor(Chart.LowerLeft.X / step) * step;
-          PointD current = new PointD(x, Point.Y);
+          var current = new PointD(x, Point.Y);
           while (current.X <= Chart.UpperRight.X) {
             Point p = Chart.TransformWorldToPixel(current);
@@ -83,5 +76,5 @@
       }
       if ((AxisType & AxisType.Vertical) == AxisType.Vertical) {
-        int intervals = Chart.SizeInPixels.Height / pixelsPerInterval;
+        int intervals = Chart.SizeInPixels.Height / PixelsPerInterval;
 
         if (intervals > 0) {
@@ -94,5 +87,5 @@
 
           double y = Math.Floor(Chart.LowerLeft.Y / step) * step;
-          PointD current = new PointD(Point.X, y);
+          var current = new PointD(Point.X, y);
           while (current.Y <= Chart.UpperRight.Y) {
             Point p = Chart.TransformWorldToPixel(current);
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/AxisPrimitiveBase.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/AxisPrimitiveBase.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/AxisPrimitiveBase.cs	(revision 13045)
@@ -20,7 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Text;
 using System.Drawing;
 
@@ -41,5 +38,5 @@
         if (value != myShowGrid) {
           myShowGrid = value;
-          OnUpdate();
+          OnRedrawRequired();
         }
       }
@@ -51,5 +48,5 @@
         if (value != myHorizontalLabel) {
           myHorizontalLabel = value;
-          OnUpdate();
+          OnRedrawRequired();
         }
       }
@@ -61,5 +58,5 @@
         if (value != myVerticalLabel) {
           myVerticalLabel = value;
-          OnUpdate();
+          OnRedrawRequired();
         }
       }
@@ -67,13 +64,5 @@
 
     protected AxisPrimitiveBase(IChart chart, PointD point, AxisType axisType)
-      : base(chart) {
-      Brush = Brushes.Black;
-      myPoint = point;
-      myAxisType = axisType;
-      myShowGrid = true;
-    }
-    protected AxisPrimitiveBase(IChart chart, double x, double y, AxisType axisType)
-      : this(chart, new PointD(x, y), axisType) {
-    }
+      : this(chart, point, axisType, Pens.Black, Brushes.Black) { }
     protected AxisPrimitiveBase(IChart chart, PointD point, AxisType axisType, Pen pen, Brush brush)
       : base(chart, pen, brush) {
@@ -82,21 +71,28 @@
       myShowGrid = true;
     }
-    protected AxisPrimitiveBase(IChart chart, double x, double y, AxisType axisType, Pen pen, Brush brush)
-      : this(chart, new PointD(x, y), axisType, pen, brush) {
-    }
 
     public virtual void SetPosition(PointD point) {
       myPoint = point;
-      OnUpdate();
+      OnRedrawRequired();
     }
-    public void SetPosition(double x, double y) {
-      SetPosition(new PointD(x, y));
-    }
+
     public override void Move(Offset delta) {
       SetPosition(Point + delta);
     }
 
+    public override void Move(PointD point, Offset delta) {
+      Move(delta);
+    }
+
+    public override void SnapToGrid(IGrid grid) {
+      Move(grid.GetBottomLeftGridPoint(myPoint) - myPoint);
+    }
+
+    public override void SnapToGrid(PointD point, IGrid grid) {
+      SnapToGrid(grid);
+    }
+
     public override bool ContainsPoint(PointD point) {
-      SizeD size = Chart.TransformPixelToWorld(new Size(5, 5));
+      var size = Chart.TransformPixelToWorld(new Size(5, 5));
       bool result = false;
       if ((AxisType & AxisType.Horizontal) == AxisType.Horizontal)
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Ellipse.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Ellipse.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Ellipse.cs	(revision 13045)
@@ -28,12 +28,6 @@
       : base(chart, lowerLeft, upperRight) {
     }
-    public Ellipse(IChart chart, double x1, double y1, double x2, double y2)
-      : this(chart, new PointD(x1, y1), new PointD(x2, y2)) {
-    }
     public Ellipse(IChart chart, PointD lowerLeft, PointD upperRight, Pen pen, Brush brush)
       : base(chart, lowerLeft, upperRight, pen, brush) {
-    }
-    public Ellipse(IChart chart, double x1, double y1, double x2, double y2, Pen pen, Brush brush)
-      : this(chart, new PointD(x1, y1), new PointD(x2, y2), pen, brush) {
     }
 
@@ -67,6 +61,6 @@
 
     public override void Draw(Graphics graphics) {
-      Point p = Chart.TransformWorldToPixel(new PointD(LowerLeft.X, LowerLeft.Y + Size.Height));
-      Size s = Chart.TransformWorldToPixel(Size);
+      var p = Chart.TransformWorldToPixel(new PointD(LowerLeft.X, LowerLeft.Y + Size.Height));
+      var s = Chart.TransformWorldToPixel(Size);
       if (Brush != null)
         graphics.FillEllipse(Brush, p.X, p.Y, s.Width, s.Height);
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/FixedSizeCircle.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/FixedSizeCircle.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/FixedSizeCircle.cs	(revision 13045)
@@ -27,12 +27,6 @@
       : base(chart, point, new Size(diameter, diameter)) {
     }
-    public FixedSizeCircle(IChart chart, double x, double y, int diameter)
-      : this(chart, new PointD(x, y), diameter) {
-    }
     public FixedSizeCircle(IChart chart, PointD point, int diameter, Pen pen, Brush brush)
       : base(chart, point, new Size(diameter, diameter), pen, brush) {
-    }
-    public FixedSizeCircle(IChart chart, double x, double y, int diameter, Pen pen, Brush brush)
-      : this(chart, new PointD(x, y), diameter, pen, brush) {
     }
 
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/FixedSizePrimitiveBase.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/FixedSizePrimitiveBase.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/FixedSizePrimitiveBase.cs	(revision 13045)
@@ -21,6 +21,4 @@
 
 using System;
-using System.Collections.Generic;
-using System.Text;
 using System.Drawing;
 
@@ -41,7 +39,4 @@
       mySize = size;
     }
-    protected FixedSizePrimitiveBase(IChart chart, double x, double y, Size size)
-      : this(chart, new PointD(x, y), size) {
-    }
     protected FixedSizePrimitiveBase(IChart chart, PointD point, Size size, Pen pen, Brush brush)
       : base(chart, pen, brush) {
@@ -49,17 +44,28 @@
       mySize = size;
     }
-    protected FixedSizePrimitiveBase(IChart chart, double x, double y, Size size, Pen pen, Brush brush)
-      : this(chart, new PointD(x, y), size, pen, brush) {
-    }
 
     public virtual void SetPosition(PointD point) {
       myPoint = point;
-      OnUpdate();
+      OnRedrawRequired();
     }
-    public void SetPosition(double x, double y) {
+
+    public override void Move(Offset delta) {
+      SetPosition(Point + delta);
+    }
+
+    public override void Move(PointD point, Offset delta) {
+      Move(delta);
+    }
+
+    public override void SnapToGrid(IGrid grid) {
+      var bl = grid.GetBottomLeftGridPoint(Point);
+      var ur = grid.GetUpperRightGridPoint(Point);
+      var x = Math.Abs(bl.X - Point.X) <= Math.Abs(ur.X - Point.X) ? bl.X : ur.X;
+      var y = Math.Abs(bl.Y - Point.Y) <= Math.Abs(ur.Y - Point.Y) ? bl.Y : ur.Y;
       SetPosition(new PointD(x, y));
     }
-    public override void Move(Offset delta) {
-      SetPosition(Point + delta);
+
+    public override void SnapToGrid(PointD point, IGrid grid) {
+      SnapToGrid(grid);
     }
 
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/FixedSizeRectangle.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/FixedSizeRectangle.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/FixedSizeRectangle.cs	(revision 13045)
@@ -20,7 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Text;
 using System.Drawing;
 
@@ -30,12 +27,6 @@
       : base(chart, point, size) {
     }
-    public FixedSizeRectangle(IChart chart, double x, double y, Size size)
-      : this(chart, new PointD(x, y), size) {
-    }
     public FixedSizeRectangle(IChart chart, PointD point, Size size, Pen pen, Brush brush)
       : base(chart, point, size, pen, brush) {
-    }
-    public FixedSizeRectangle(IChart chart, double x, double y, Size size, Pen pen, Brush brush)
-      : this(chart, new PointD(x, y), size, pen, brush) {
     }
 
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Grid.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Grid.cs	(revision 13045)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Primitives/Grid.cs	(revision 13045)
@@ -0,0 +1,114 @@
+﻿using System;
+using System.Drawing;
+
+namespace HeuristicLab.Visualization {
+  public class Grid : PrimitiveBase, IGrid {
+    protected const int CellSpacing = 10;
+
+    public virtual PointD Origin { get; set; }
+    public virtual PointD Offset { get; set; }
+    public virtual SizeD Size { get; set; }
+
+    public virtual double XPrecision { get; set; }
+    public virtual double YPrecision { get; set; }
+
+    public virtual PointD GetBottomLeftGridPoint(PointD point) {
+      var nx = (int)Math.Floor((point.X - Origin.X) / XPrecision);
+      var ny = (int)Math.Floor((point.Y - Origin.Y) / YPrecision);
+      return new PointD(Origin.X + nx * XPrecision, Origin.Y + ny * YPrecision);
+    }
+
+    public virtual PointD GetUpperRightGridPoint(PointD point) {
+      var nx = (int)Math.Ceiling((point.X - Origin.X) / XPrecision);
+      var ny = (int)Math.Ceiling((point.Y - Origin.Y) / YPrecision);
+      return new PointD(Origin.X + nx * XPrecision, Origin.Y + ny * YPrecision);
+    }
+
+    public virtual PointD GetNearestGridPoint(PointD point) {
+      var bl = GetBottomLeftGridPoint(point);
+      var ur = GetUpperRightGridPoint(point);
+      return new PointD(
+        Math.Abs(bl.X - point.X) <= Math.Abs(ur.X - point.X) ? bl.X : ur.X,
+        Math.Abs(bl.Y - point.Y) <= Math.Abs(ur.Y - point.Y) ? bl.Y : ur.Y);
+    }
+
+    public Grid(IChart chart, PointD offset, SizeD size)
+      : this(chart, offset, size, 1) { }
+    public Grid(IChart chart, PointD offset, SizeD size, double precision)
+      : base(chart) {
+      Origin = new PointD(0, 0);
+      Offset = offset;
+      Size = size;
+      XPrecision = precision;
+      YPrecision = precision;
+    }
+
+    public override bool ContainsPoint(PointD point) {
+      return false;
+    }
+
+    public override void Move(Offset delta) {
+      Offset += delta;
+    }
+
+    public override void Move(PointD point, Offset delta) {
+      Move(delta);
+    }
+
+    public override void SnapToGrid(IGrid grid) { }
+
+    public override void SnapToGrid(PointD point, IGrid grid) { }
+
+    public override void Draw(Graphics graphics) {
+      if (!(Size.Width > 0) || !(Size.Height > 0)) return;
+      graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.SingleBitPerPixelGridFit;
+      var pen = new Pen(Color.LightGray, 1.0f);
+      var pixelSize = Chart.TransformWorldToPixel(Size); // size of the drawing area in pixel coordinates
+
+      var numberOfXParallelLines = (int)Math.Floor(pixelSize.Height / (double)CellSpacing); // how many x parallel lines can be drawn
+      var numberOfYParallelLines = (int)Math.Floor(pixelSize.Width / (double)CellSpacing); // how many y parallel lines can be drawn
+      if (numberOfXParallelLines <= 0 || numberOfYParallelLines <= 0) return;
+      var cellWorldSize = new SizeD(Size.Width / numberOfYParallelLines, Size.Height / numberOfXParallelLines); // the cellSize in world coordinates
+      cellWorldSize.Width = Math.Pow(10, Math.Floor(Math.Log10(cellWorldSize.Width)));
+      cellWorldSize.Height = Math.Pow(10, Math.Floor(Math.Log10(cellWorldSize.Width)));
+      var cellPixelSize = Chart.TransformWorldToPixel(cellWorldSize);
+      while (cellPixelSize.Width < 25 || cellPixelSize.Height < 25) {
+        if (cellPixelSize.Width < 25) cellWorldSize.Width *= 2;
+        if (cellPixelSize.Height < 25) cellWorldSize.Height *= 2;
+        cellPixelSize = Chart.TransformWorldToPixel(cellWorldSize);
+        if (cellPixelSize.Width < 25) cellWorldSize.Width *= 2.5;
+        if (cellPixelSize.Height < 25) cellWorldSize.Height *= 2.5;
+        cellPixelSize = Chart.TransformWorldToPixel(cellWorldSize);
+      }
+      var firstX = Math.Floor(Offset.X / cellWorldSize.Width) * cellWorldSize.Width;
+      var firstY = Math.Floor(Offset.Y / cellWorldSize.Height) * cellWorldSize.Height;
+      double x = firstX, y = firstY;
+      var axisyLabel = new Font(FontFamily.GenericMonospace, 7.0f, FontStyle.Regular, GraphicsUnit.Point, 0);
+      var axisxLabel = new Font(FontFamily.GenericMonospace, 7.0f, FontStyle.Regular, GraphicsUnit.Point, 0, true);
+      var axisDrawing = new SolidBrush(Color.DarkGray);
+      try {
+        var bottom = Chart.TransformWorldToPixel(Size).Height;
+        while (x <= Offset.X + Size.Width) {
+          var start = Chart.TransformWorldToPixel(new PointD(x, firstY));
+          var end = Chart.TransformWorldToPixel(new PointD(x, Offset.Y + Size.Height));
+          graphics.DrawLine(pen, start, end);
+          var axis = x.ToString("0.##");
+          double stringwidth = graphics.MeasureString(axis, axisyLabel).Width;
+          graphics.DrawString(axis, axisyLabel, axisDrawing, end.X - (int)(stringwidth / 2.0), bottom - 15);
+          x += cellWorldSize.Width;
+        }
+        while (y <= Offset.Y + Size.Height) {
+          var start = Chart.TransformWorldToPixel(new PointD(firstX, y));
+          var end = Chart.TransformWorldToPixel(new PointD(Offset.X + Size.Width, y));
+          graphics.DrawLine(pen, start, end);
+          graphics.DrawString(y.ToString("0.##"), axisxLabel, axisDrawing, 0, start.Y);
+          y += cellWorldSize.Height;
+        }
+      } finally {
+        axisDrawing.Dispose();
+        axisxLabel.Dispose();
+        axisyLabel.Dispose();
+      }
+    }
+  }
+}
